###################################################
### chunk number 1: 
###################################################
library("clues")


###################################################
### chunk number 2: 
###################################################
data("iris")
head(iris)
dat.s <- as.matrix(iris[, -5])
colnames(dat.s) <- c("SL", "SW", "PL", "PW")


###################################################
### chunk number 3: 
###################################################
pairs(dat.s)


###################################################
### chunk number 4: 
###################################################
res.sil <- clues(dat.s, strengthMethod = "sil", disMethod = "Euclidean")
res.sil
res.CH <- clues(dat.s, strengthMethod = "CH", disMethod = "Euclidean")
res.CH


###################################################
### chunk number 5: 
###################################################
plotClusters(dat.s, res.sil$mem, plot.dim=1:4)


###################################################
### chunk number 6: 
###################################################
plotClusters(dat.s, res.CH$mem, plot.dim=1:4)


###################################################
### chunk number 7: 
###################################################
plotAvgCurves(dat.s, res.sil$mem)


###################################################
### chunk number 8: 
###################################################
plotAvgCurves(dat.s, res.CH$mem)


###################################################
### chunk number 9: 
###################################################
library(cluster)
library(stats)
iris.mem <- rep(1, dim(iris)[1])
iris.mem[iris$Species == "versicolor"] <- 2
iris.mem[iris$Species == "virginica"] <- 3
res.km <- kmeans(dat.s, 3, algorithm = "MacQueen")
res.pam <- pam(dat.s, 3)
memMat <- cbind(iris.mem, res.CH$mem, res.sil$mem, res.km$cluster, res.pam$clustering)
colnames(memMat) <- c("true", "clues.CH", "clues.sil", "km", "pam")
tt <- compClust(dat.s, memMat)
print(sapply(tt, function(x) { round(x, 2) }))


###################################################
### chunk number 10: 
###################################################
iris.mem1 <- rep(2, dim(iris)[1])
iris.mem1[iris$Species == "setosa"] <- 1
res.km1 <- kmeans(dat.s, 2, algorithm = "MacQueen")
res.pam1 <- pam(dat.s, 2)
memMat1 <- cbind(iris.mem1, res.CH$mem, res.sil$mem, res.km1$cluster, res.pam1$clustering)
colnames(memMat1) <- c("true", "clues.CH", "clues.sil", "km", "pam")
tt <- compClust(dat.s, memMat1)
print(sapply(tt, function(x) { round(x, 2) }))


###################################################
### chunk number 11: 
###################################################
shrinkres <- shrinking(dat.s, K = 60, disMethod = "Euclidean")
dimnames(shrinkres) <- dimnames(dat.s)


###################################################
### chunk number 12: 
###################################################
pairs(shrinkres) 


